\documentclass{beamer}

\usepackage[babelshorthands]{polyglossia}
\setdefaultlanguage{english}

\usepackage{fontawesome}

\include{listings}

\usetheme{treeptik}

\AtBeginSection{
\frame{\sectionpage}
}

\newcommand{\social}[1]{{\color{tkcyan} #1}}

\title{Just Run It}
\author[William Bartlett]{William Bartlett \\
  \texorpdfstring{\social\faAt\, w.bartlett@treeptik.fr
  \quad \social\faTwitter\, @bartlettstarman}{} \\
  \texorpdfstring{\social\faLinkedinSquare\, \href{https://www.linkedin.com/in/punkstarman￼}{punkstarman}
  \quad \social\faGithub\, punkstarman}{}}
\institute{Treeptik}
\logo{\includegraphics[width=16px]{treeptik-card.png}}
\date{28th March 2019}

\newenvironment{layout-image-left}[1]{%
\begin{columns}
\begin{column}{0.4\textwidth}
\includegraphics[height=\textheight,width=\textwidth,keepaspectratio]{#1}
\end{column}
\begin{column}{0.5\textwidth}
}{%
\end{column}
\end{columns}
}

\newcommand{\layoutimagefull}[1]{
  \begin{center}
    \includegraphics[height=0.8\textheight,width=0.8\textwidth,keepaspectratio]{#1}
  \end{center}
}

\newcommand{\layoutimagecaption}[1]{
  \begin{center}
    \includegraphics[height=0.7\textheight,width=0.8\textwidth,keepaspectratio]{#1}
  \end{center}
}

\begin{document}

\maketitle

\begin{frame} \frametitle{Just Run It}

  \begin{center}
    Don't install
    \vfill
    Just run
    \vfill
    \mintinline{text}{docker run}
  \end{center}

\end{frame}

\begin{frame} \frametitle{Let's meet}

  \begin{layout-image-left}{Photo.jpg}
    William Bartlett, Treeptik
    \vfill
    \begin{itemize}
      \item Agile Coach, Dev
      \item Docker enthusiast
      \item Windows detractor
    \end{itemize}
    \vfill
    \begin{quote} ``Use the right tool for the job'' \end{quote}
  \end{layout-image-left}

\end{frame}


\begin{frame} \frametitle{A Day in the Life}

  \layoutimagefull{surrounded.png}

\end{frame}

\begin{frame} \frametitle{So?}

  \begin{block}{Problem}
    How do you work with varying tech stacks without going mad?
  \end{block}

  \vfill

  \begin{block}{Solution}
    Use containers!
  \end{block}

\end{frame}

\begin{frame} \frametitle{It's not Docker's 2nd birthday}

  \begin{center}
    \includegraphics[height=0.8\textheight,width=\textwidth,keepaspectratio]{docker-bday.png}
  \end{center}

\end{frame}

\begin{frame}[fragile] \frametitle{We know}

  \begin{minted}{shell}
  $ sudo apt install mysql

  $ docker run mysql

  $ docker-compose up -d
  \end{minted}

  \vfill

  Really?

  \begin{minted}{shell}
  $ docker run ... maven
  \end{minted}

\end{frame}

\begin{frame} \frametitle{Outline}

  \tableofcontents

\end{frame}

\begin{frame} \frametitle{Source Code}

  All source code at

  \begin{center}
    \url{https://gitlab.com/namrats/talks/just-run-it}
  \end{center}

  \vfill
  A link to the slides will be tweeted.

\end{frame}

\section{Related Solutions}

\begin{frame} \frametitle{Related Solutions}

  \begin{itemize}
    \item Workstation as Code w/Ansible
    \item Virtualization w/Vagrant
    \vfill
    \item Virtualenv/Pipenv for Python
    \item NPM for Node
    \vfill
    \item Cloud IDE w/Eclipse Che
  \end{itemize}

\end{frame}

\section{Maven Wrapper}

\begin{frame}[fragile] \frametitle{Maven Wrapper}

  Requirements
  \begin{itemize}
    \item Shell
    \item Docker
  \end{itemize}

  \vfill

  \begin{minted}{shell}
  UID=$(id -u)
  GID=$(id -g)

  MAVEN_VERSION="3.6.0-jdk-8-alpine"
  MAVEN_OPTS="-Duser.home=/var/maven"

  exec docker run -it --rm -u $UID:$GID \
    -v $HOME/.m2:/var/maven/.m2 \
    -v $PWD:/usr/src/$(basename $PWD) \
    -w /usr/src/$(basename $PWD) \
    -e HOME=/var/maven \
    -e MAVEN_CONFIG=/var/maven/.m2 \
    maven:$MAVEN_VERSION mvn $MAVEN_OPTS "$@"
  \end{minted}

\end{frame}

\begin{frame} \frametitle{Maven Wrapper}

  Concerns
  \begin{itemize}
    \item Caching w/volume
  \end{itemize}

  \vfill

  Difficulties
  \begin{itemize}
    \item IDE integration
  \end{itemize}

\end{frame}


\section{Haskell Stack}

\begin{frame}[fragile] \frametitle{Haskell Stack}

  Requirements
  \begin{itemize}
    \item Shell
    \item Docker
    \item Stack
  \end{itemize}

  \vfill

  \mintinline{text}{stack.yaml}
  \begin{minted}{yaml}
  resolver: lts-13.14

  docker:
    enable: true
  \end{minted}

\end{frame}

\begin{frame} \frametitle{Haskell Stack}

  Concerns
  \begin{itemize}
    \item IDE integration w/LSP
  \end{itemize}

  \vfill

  Difficulties
  \begin{itemize}
    \item Image size
  \end{itemize}

\end{frame}


\section{LaTeX Presentation}

\begin{frame}[fragile] \frametitle{LaTeX Presentation}

  Requirements
  \begin{itemize}
    \item Shell
    \item Docker
    \item Make
  \end{itemize}

  \vfill

  \begin{minted}{make}
  DOCKERFLAGS=-it --rm -u $(UID):$(GID) \
    -v $(LUATEX_CACHE):$(LUATEX_CACHE) \
    -v $(CURDIR)/fonts:/usr/local/share/fonts \
    -v $(CURDIR):/data \
    -w /data \
    -e HOME=/tmp

  TEX_SCRIPT=for run in $$(seq 2) ; \
    do $(TEX) $(TEXFLAGS) $< ; \
    done

  $(PROJECT_NAME).pdf: main.tex *.tex $(LUATEX_CACHE)
    docker run $(DOCKERFLAGS) $(DOCKERIMAGE) \
      sh -c '$(TEX_SCRIPT)'
  \end{minted}

\end{frame}

\begin{frame} \frametitle{LaTeX Presentation}

  Concerns
  \begin{itemize}
    \item Caching w/volume
  \end{itemize}

  Difficulties
  \begin{itemize}
    \item IDE integration
  \end{itemize}

\end{frame}

\section*{Conclusion}

\begin{frame} \frametitle{Conclusion}

  \begin{itemize}
    \item Wrapper shell script
    \vfill
    \item Tool integration
    \vfill
    \item Makefile
  \end{itemize}

  \vfill

  Future work
  \begin{itemize}
    \item More tool integration, please
    \item containerized desktop apps (IDE)
  \end{itemize}

\end{frame}

\end{document}
